declare type EventsMap = {
    [k: string]: (...args: any[]) => void;
};
export declare class EventManager<Events extends EventsMap> {
    private listeners;
    on: <E extends keyof Events>(event: E, listener: Events[E]) => void;
    off: <E extends keyof Events>(event: E, listener: Events[E]) => void;
    emit: <E extends keyof Events>(event: E, data: Parameters<Events[E]>[0]) => void;
    removeAllListeners: () => void;
}
export {};
