import { IElementClickedMessageData } from './IFrameCommunicator';
export declare enum NodeSmartLinkProviderEventType {
    ElementClicked = "kontent-smart-link:element:clicked"
}
export declare type NodeSmartLinkProviderMessagesMap = {
    readonly [NodeSmartLinkProviderEventType.ElementClicked]: (data: Partial<IElementClickedMessageData>) => void;
};
export declare class NodeSmartLinkProvider {
    enabled: boolean;
    private readonly events;
    private readonly mutationObserver;
    private readonly intersectionObserver;
    private readonly renderer;
    private renderingTimeoutId;
    private observedElements;
    private visibleElements;
    constructor();
    destroy: () => void;
    addEventListener: <E extends NodeSmartLinkProviderEventType.ElementClicked>(type: E, listener: NodeSmartLinkProviderMessagesMap[E]) => void;
    removeEventListener: <E extends NodeSmartLinkProviderEventType.ElementClicked>(type: E, listener: NodeSmartLinkProviderMessagesMap[E]) => void;
    enable: () => void;
    disable: () => void;
    private highlightVisibleElements;
    /**
     * Start an interval rendering (1s) that will re-render highlights for all visible elements using `setTimeout`.
     * It helps to adjust highlights position even in situations that are currently not supported by
     * the SDK (e.g. element position change w/o animations, some infinite animations and other possible unhandled cases)
     * for better user experience.
     */
    private startRenderingInterval;
    private stopRenderingInterval;
    private listenToGlobalEvents;
    private unlistenToGlobalEvents;
    private observeDomMutations;
    private disconnectObservers;
    private observeElementVisibility;
    private unobserveElementVisibility;
    private onDomMutation;
    private onElementVisibilityChange;
    private onElementClick;
    private onElementMouseEnter;
    private onElementMouseLeave;
}
